

{
	Graphics.i
		This is the include file needed to use graphics routines
	from PCQ Pascal.  Before you use any of these routines, be
	sure to open the Graphics library and get a valid library pointer into
	GfxBase.
}

type
    PlanePtr = Address;

    TmpRas = record
	rasPtr : Address;
	size   : Integer;
    end;
    TmpRasPtr = ^TmpRas;

    BitMap = record
	BytesPerRow : Short;
	Rows	    : Short;
	Flags	    : Byte;
	Depth	    : Byte;
	Pad	    : Short;
	Planes	    : array [0..7] of PlanePtr;
    end;
    BitMapPtr = ^BitMap;

    RastPort = record
	layer    : Address;
	bitMap   : BitMapPtr;
	AreaPtrn : ^Short;
	tmpRas   : TmpRasPtr;
	areaInfo : Address;
	gelsInfo : Address;
	Mask     : Byte;
	FgPen    : Byte;
	BgPen    : Byte;
	AOlPen   : Byte;
	DrawMode : Byte;
	AreaPtSz : Byte;
	linpatcnt: Byte;
	Flags    : Short;
	LinePtrn : Short;
	cpx      : Short;
	cpy      : Short;
	minterms : Array [0..7] of Byte;
	PenWidth : Short;
	PenHeight: Short;
	Font     : Address;
	AlgoStyle: Byte;
	TxFlags  : Byte;
	TxHeight : Short;
	TxWidth  : Short;
	TxBaseline : Short;
	TxSpacing : Short;
	RPUser   : Integer;
	wordreserved : array [0..6] of Short;
	longreserved : array [0..1] of Integer;
	reserved : array [0..7] of Byte;
    end;
    RastPortPtr = ^RastPort;

var
    GfxBase	: Address;

Function AllocRaster(w, h : Integer): PlanePtr;
    forward;
Function AreaDraw(r : RastPortPtr; x, y : Integer): Integer;
    forward;
Procedure AreaEnd(r : RastPortPtr);
    forward;
Function AreaMove(r : RastPortPtr; x, y : Integer): Integer;
    forward;
Procedure BltClear(m : Address; c : Integer; f : Integer);
    forward;
Procedure Draw(r : RastPortPtr; x, y : Integer);
    forward;
Procedure Flood(r : RastPortPtr; f, x, y : Integer);
    forward;
Procedure FreeRaster(p : PlanePtr; w, h : Integer);
    forward;
Procedure InitBitMap(b : BitMapPtr; d, w, h : Integer);
    forward;
Procedure InitRastPort(r : RastPortPtr);
    forward;
Procedure Move(r : RastPortPtr; x, y : Integer);
    forward;
Procedure OwnBlitter;
    forward;
Procedure DisownBlitter;
    forward;
Procedure PolyDraw(r : RastPortPtr; c : Integer; a : Address);
    forward;
Function ReadPixel(r : RastPortPtr; x, y : Integer): Integer;
    forward;
Procedure RectFill(r : RastPortPtr; xn, yn, xx, yx : Integer);
    forward;
Procedure ScrollRaster(r : RastPortPtr; dx, dy, xn, yn, xx, yx : Integer);
    forward;
Procedure SetAPen(r : RastPortPtr; p : Integer);
    forward;
Procedure SetBPen(r : RastPortPtr; p : Integer);
    forward;
Procedure SetDrMd(r : RastPortPtr; m : Integer);
    forward;
Procedure SetRast(r : RastPortPtr; p : Integer);
    forward;
Procedure SetRGB4(p : Address; n, r, g, b : Integer);
    forward;
Function VBeamPos() : Integer;
    forward;
Procedure WaitTOF;
    forward;
Procedure WritePixel(r : RastPortPtr; x, y : Integer);
    forward;

