
*	Intuition.asm (of PCQ Pascal runtime library)
*	Copyright (c) 1989 Patrick Quaid

*	This simply implements the intuition routines.  Again you don't
*	need to make a new pointer to the library, since we just use the
*	one created by the start up code.

	XREF	_p%IntuitionBase

	section	one

	XDEF	_OpenWindow
_OpenWindow
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOOpenWindow(a6)
	rts

	XDEF	_CloseWindow
_CloseWindow
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOCloseWindow(a6)
	rts

	XDEF	_OpenScreen
_OpenScreen
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOOpenScreen(a6)
	rts

	XDEF	_CloseScreen
_CloseScreen
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOCloseScreen(a6)
	rts

	XDEF	_CurrentTime
_CurrentTime
	move.l	8(sp),d0
	move.l	4(sp),d1
	move.l	_p%IntuitionBase,a6
	jsr	_LVOCurrentTime(a6)
	rts

	XDEF	_MoveScreen
_MoveScreen
	move.l	12(sp),a0
	move.l	8(sp),d0
	move.l	4(sp),d1
	move.l	_p%IntuitionBase,a6
	jsr	_LVOMoveScreen(a6)
	rts

	XDEF	_MoveWindow
_MoveWindow
	move.l	12(sp),a0
	move.l	8(sp),d0
	move.l	4(sp),d1
	move.l	_p%IntuitionBase,a6
	jsr	_LVOMoveWindow(a6)
	rts

	XDEF	_ScreenToBack
_ScreenToBack
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOScreenToBack(a6)
	rts

	XDEF	_ScreenToFront
_ScreenToFront
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOScreenToFront(a6)
	rts

	XDEF	_SetWindowTitles
_SetWindowTitles
	move.l	a2,-(sp)
	move.l	16(sp),a0
	move.l	12(sp),a1
	move.l	8(sp),a2
	move.l	_p%IntuitionBase,a6
	jsr	_LVOSetWindowTitles(a6)
	move.l	(sp)+,a2
	rts

	XDEF	_ShowTitle
_ShowTitle
	move.l	6(sp),a0
	move.w	4(sp),d0
	and.l	#$FF,d0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOShowTitle(a6)
	rts

	XDEF	_SizeWindow
_SizeWindow
	move.l	12(sp),a0
	move.l	8(sp),d0
	move.l	4(sp),d0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOSizeWindow(a6)
	rts

	XDEF	_ViewPortAddress
_ViewPortAddress
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOViewPortAddress(a6)
	rts

	XDEF	_WBenchToBack
_WBenchToBack
	move.l	_p%IntuitionBase,a6
	jsr	_LVOWBenchToBack(a6)
	rts

	XDEF	_WBenchToFront
_WBenchToFront
	move.l	_p%IntuitionBase,a6
	jsr	_LVOWBenchToFront(a6)
	rts

	XDEF	_WindowToBack
_WindowToBack
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOWindowToBack(a6)
	rts

	XDEF	_WindowToFront
_WindowToFront
	move.l	4(sp),a0
	move.l	_p%IntuitionBase,a6
	jsr	_LVOWindowToFront(a6)
	rts


*	XREF	_LVONewModifyProp
*	XREF	_LVOActivateGadget
*	XREF	_LVORefreshWindowFrame
*	XREF	_LVOActivateWindow
*	XREF	_LVORemoveGList
*	XREF	_LVOAddGList
*	XREF	_LVORefreshGList
*	XREF	_LVOGetScreenData
*	XREF	_LVOUnlockIBase
*	XREF	_LVOLockIBase
*	XREF	_LVOFreeRemember
*	XREF	_LVOAlohaWorkbench
*	XREF	_LVOAllocRemember
*	XREF	_LVORethinkDisplay
*	XREF	_LVORemakeDisplay
*	XREF	_LVOMakeScreen
*	XREF	_LVOFreeSysRequest
*	XREF	_LVOEndRefresh
*	XREF	_LVOBuildSysRequest
*	XREF	_LVOBeginRefresh
*	XREF	_LVOAutoRequest
	XREF	_LVOWBenchToFront
	XREF	_LVOWBenchToBack
*	XREF	_LVOIntuiTextLength
*	XREF	_LVOSetPrefs
*	XREF	_LVOWindowLimits
	XREF	_LVOWindowToFront
	XREF	_LVOWindowToBack
	XREF	_LVOViewPortAddress
*	XREF	_LVOViewAddress
	XREF	_LVOSizeWindow
	XREF	_LVOShowTitle
	XREF	_LVOSetWindowTitles
*	XREF	_LVOSetPointer
*	XREF	_LVOSetMenuStrip
*	XREF	_LVOSetDMRequest
	XREF	_LVOScreenToFront
	XREF	_LVOScreenToBack
*	XREF	_LVORequest
*	XREF	_LVOReportMouse
*	XREF	_LVORemoveGadget
*	XREF	_LVORefreshGadgets
*	XREF	_LVOPrintIText
*	XREF	_LVOOpenWorkBench
	XREF	_LVOOpenWindow
	XREF	_LVOOpenScreen
*	XREF	_LVOOnMenu
*	XREF	_LVOOnGadget
*	XREF	_LVOOffMenu
*	XREF	_LVOOffGadget
	XREF	_LVOMoveWindow
	XREF	_LVOMoveScreen
*	XREF	_LVOModifyProp
*	XREF	_LVOModifyIDCMP
*	XREF	_LVOItemAddress
*	XREF	_LVOInitRequester
*	XREF	_LVOGetPrefs
*	XREF	_LVOGetDefPrefs
*	XREF	_LVOEndRequest
*	XREF	_LVODrawImage
*	XREF	_LVODrawBorder
*	XREF	_LVODoubleClick
*	XREF	_LVODisplayBeep
*	XREF	_LVODisplayAlert
	XREF	_LVOCurrentTime
*	XREF	_LVOCloseWorkBench
	XREF	_LVOCloseWindow
	XREF	_LVOCloseScreen
*	XREF	_LVOClearPointer
*	XREF	_LVOClearMenuStrip
*	XREF	_LVOClearDMRequest
*	XREF	_LVOAddGadget
*	XREF	_LVOIntuition
*	XREF	_LVOOpenIntuition

	end
